#ifndef SFILEDLG_H
#define SFILEDLG_H

/* Dialog Control IDs */
#define     IDD_FILENAME    400
#define     IDD_DIRS        401
#define     IDD_PATH        402
#define     IDD_TYPES       403

/* Bitmap IDs */
#define     BMP_FOLDER      100
#define     BMP_REMOVE      101
#define     BMP_FIXED       102
#define     BMP_REMOTE      103
#define     BMP_CDROM       104
#define     BMP_RAM         105
#define     BMP_SUBST       106
#define     BMP_FOLDERM     200
#define     BMP_REMOVEM     201
#define     BMP_FIXEDM      202
#define     BMP_REMOTEM     203
#define     BMP_CDROMM      204
#define     BMP_RAMM        205
#define     BMP_SUBSTM      206

/* Types */
typedef struct
{
    char        szFile[13];             // Wildcard file type
    char        szDesc[32];             // Description of this file
} SFType;

typedef struct
{
    HWND        hWnd;                   // Parent of dialog box
    SFType FAR* lpTypes;                // Array of SFType, last element in
                                        //   this array should be empty
    int         nType;                  // Default type spec, an index to lpTypes
    LPSTR       lpszFileSpec;           // Default file name, on return this
                                        //   buffer contains the selected file
    int         nMaxFileSpec;           // lpszFileSpec buffer size
    LPSTR       lpszTitle;              // Dialog box window title
} SFDlg;

/* Function Prototypes */
int FAR PASCAL _export SFileDlg(SFDlg FAR* sfdlg);
#endif

